--- ssh-1.2.20/gmp-2.0.2-ssh-2/config.sub.rmk	Tue Oct 29 23:01:48 1996
+++ ssh-1.2.20/gmp-2.0.2-ssh-2/config.sub	Sat Aug  9 20:53:50 1997
@@ -235,6 +235,9 @@
 		basic_machine=arm-arm
 		os=-aout
 		;;
+	arm* | sa110*)
+		basic_machine=arm-`echo $basic_machine | sed 's/^[^-]*-//'`
+		;;
 	balance)
 		basic_machine=ns32k-sequent
 		os=-dynix
--- ssh-1.2.20/gmp-2.0.2-ssh-2/gmp-impl.h.rmk	Tue Oct 29 23:01:52 1996
+++ ssh-1.2.20/gmp-2.0.2-ssh-2/gmp-impl.h	Sat Aug  9 20:54:33 1997
@@ -281,7 +281,7 @@
 
 #if SIZEOF_INT >= 4 /* otherwise fails on 16-bit machines */
 #if defined (__alpha)							\
- || (defined (__arm__) && defined (__ARMWEL__))				\
+ || (defined (__arm__) && defined (__ARMWEL__) && !defined (__linux__))	\
  || defined (__clipper__)						\
  || defined (__cris)							\
  || defined (__i386__)							\
@@ -304,7 +304,7 @@
 };
 #else /* Need this as an #else since the tests aren't made exclusive.  */
 #if defined (__a29k__) || defined (_AM29K)				\
- || defined (__arm__)							\
+ || (defined (__arm__) && !defined (__linux__))				\
  || (defined (__convex__) && defined (_IEEE_FLOAT_))			\
  || defined (__i370__) || defined (__mvs__)				\
  || defined (__mc68000__) || defined (__mc68020__) || defined (__NeXT__)\
@@ -330,6 +330,21 @@
     } s;
   double d;
 };
+#else
+#if (defined (__arm__) && defined(__linux))
+#define _GMP_IEEE_FLOATS 1
+union ieee_double_extract
+{
+  struct
+    {
+      unsigned int manh:20;
+      unsigned int exp:11;
+      unsigned int sig:1;
+      unsigned int manl:32;
+    } s;
+  double d;
+};
+#endif
 #endif
 #endif
 #endif /* SIZEOF_INT >= 4 */
--- ssh-1.2.20/gmp-2.0.2-ssh-2/longlong.h.rmk	Tue Mar 25 06:20:56 1997
+++ ssh-1.2.20/gmp-2.0.2-ssh-2/longlong.h	Sat Aug  9 20:54:33 1997
@@ -193,9 +193,9 @@
 #define umul_ppmm(xh, xl, a, b) \
   __asm__ ("%@ Inlined umul_ppmm
 	mov	%|r0, %2, lsr #16
-	mov	%|r2, %3, lsr #16
+	mov	%0, %3, lsr #16
 	bic	%|r1, %2, %|r0, lsl #16
-	bic	%|r2, %3, %|r2, lsl #16
+	bic	%|r2, %3, %0, lsl #16
 	mul	%1, %|r1, %|r2
 	mul	%|r2, %|r0, %|r2
 	mul	%|r1, %0, %|r1
--- ssh-1.2.20/config.sub.rmk	Wed Apr 23 01:40:06 1997
+++ ssh-1.2.20/config.sub	Sat Aug  9 20:53:50 1997
@@ -235,6 +235,9 @@
 		basic_machine=arm-arm
 		os=-aout
 		;;
+	arm* | sa110*)
+		basic_machine=arm-`echo $basic_machine | sed 's/^[^-]*-//'`
+		;;
 	balance)
 		basic_machine=ns32k-sequent
 		os=-dynix
--- ssh-1.2.20/Makefile.in.rmk	Sat Aug  9 20:53:44 1997
+++ ssh-1.2.20/Makefile.in	Sat Aug  9 20:53:50 1997
@@ -241,7 +241,7 @@
 GMPDEP 		= $(GMPDIR)/gmp.h $(GMPDIR)/libgmp.a
 
 ZLIBDIR		= 
-ZLIBDEP		= /usr/lib/libz.so.1
+ZLIBDEP		= /usr/lib/libz.a
 ZLIBLIBS	= -lz
 
 RSAREFDIR	= rsaref2
